package com.miaxis.test.feign;

import com.miaxis.HzgzptApplication;
import com.miaxis.feign.IQgptService;
import com.miaxis.test.Impl.TestServiceImpl;
import com.miaxis.common.sign.ISign;
import com.miaxis.common.sign.PlatUtil;
import com.miaxis.common.sign.Sign;
import org.apache.commons.httpclient.methods.multipart.FilePart;
import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
import org.apache.commons.httpclient.methods.multipart.Part;
import org.apache.commons.httpclient.params.HttpMethodParams;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import java.util.Enumeration;
import java.util.Map;

@SpringBootTest(classes = HzgzptApplication.class)
@RunWith(SpringRunner.class)
public class FeignTest {

    public static String qgptHttpTopServerPath = "http://114.55.58.112:8085/top/";
    public static String qgptHttpServerPath = "http://115.29.171.186:8085/";
    public static final String file_stuimg = "stuimg";//学员头像
    /** 接口服务器:Imageup (文件资料信息上传) */
    public static final String httpServer_Imageup = "imageup";


    @Resource
    private TestServiceImpl testService;

    @Resource
    private IQgptService qgptService;


    @Test
    public void test2() throws Exception {
        File file =new File("F:/doc/img/gen-view.jpg");
        long timestamp = System.currentTimeMillis(); // 时间戳
        String sign_str = ""; // 签名
        /* 获取签名 */
        String path = getClass().getResource("/").getPath();
        java.io.File jarFile = new java.io.File(path);
        String propertiesfile = jarFile.getParentFile().getAbsolutePath().replace("%20", " ");
        KeyStore keyStore = KeyStore.getInstance("PKCS12");
        InputStream input = new FileInputStream(propertiesfile + PlatUtil.privateKeyUrl);
        keyStore.load(input, PlatUtil.keyPassword.toCharArray());
        Enumeration<String> aliases = keyStore.aliases();
        if (!aliases.hasMoreElements()) {
            throw new RuntimeException("HTTP接口协议签名获取失败: no alias found");
        }
        String alias = aliases.nextElement();
        PrivateKey privateKey = (PrivateKey) keyStore.getKey(alias, PlatUtil.keyPassword.toCharArray()); // 私钥
        ISign sign = new Sign();
        byte[] data = PlatUtil.getBytesFromFile(file);
        sign_str = sign.sign(data, timestamp, privateKey);

        /* 验证签名 */
        X509Certificate cert = (X509Certificate) keyStore.getCertificate(alias);
        String serialNumber = cert.getSerialNumber().toString(); // 证书序列号
        long snInteger = Long.parseLong(serialNumber);
        serialNumber = Long.toHexString(snInteger).toUpperCase();

        FilePart fp = new FilePart("file", file);
        Part[] parts = { fp };
        MultipartRequestEntity entity = new MultipartRequestEntity(parts,new HttpMethodParams());

        Map resultMap = qgptService.imageup(PlatUtil.url_version, System.currentTimeMillis(), serialNumber, sign_str, entity);
        System.out.println(resultMap);
        //System.out.println(testService.imageUpForQG(file,this.httpServer_Imageup,this.file_stuimg,""));
    }






}
