package com.miaxis.school.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.miaxis.school.domain.SchoolClassType;
import com.miaxis.school.mapper.SchoolClassTypeMapper;
import com.miaxis.school.service.ISchoolClassTypeService;
import org.springframework.stereotype.Service;
import org.apache.commons.lang3.StringUtils;

import javax.annotation.Resource;
import java.util.List;


/**
 * 驾校班型Service业务层处理
 *
 * @author wwl
 * @date 2021-01-15
 */
@Service
public class SchoolClassTypeServiceImpl extends ServiceImpl<SchoolClassTypeMapper, SchoolClassType> implements ISchoolClassTypeService {

    @Resource
    private SchoolClassTypeMapper schoolClassTypeMapper;

    /**
     * 班型查询列表
     */
    @Override
    public List<SchoolClassType> queryList(SchoolClassType schoolClassType) {
        LambdaQueryWrapper<SchoolClassType> lqw = Wrappers.lambdaQuery();
                        if (StringUtils.isNotBlank(schoolClassType.getClassName())){
            lqw.like(SchoolClassType::getClassName ,schoolClassType.getClassName());
        }
                                    if (schoolClassType.getTotalPrice() != null){
            lqw.eq(SchoolClassType::getTotalPrice ,schoolClassType.getTotalPrice());
        }
                                    if (schoolClassType.getTrain() != null){
            lqw.eq(SchoolClassType::getTrain ,schoolClassType.getTrain());
        }
                                    if (StringUtils.isNotBlank(schoolClassType.getPxcx())){
            lqw.eq(SchoolClassType::getPxcx ,schoolClassType.getPxcx());
        }
                                    if (schoolClassType.getPayType() != null){
            lqw.eq(SchoolClassType::getPayType ,schoolClassType.getPayType());
        }
                                    if (schoolClassType.getMinPrice() != null){
            lqw.eq(SchoolClassType::getMinPrice ,schoolClassType.getMinPrice());
        }
                                    if (schoolClassType.getOneTime() != null){
            lqw.eq(SchoolClassType::getOneTime ,schoolClassType.getOneTime());
        }
                                    if (schoolClassType.getTwoTime() != null){
            lqw.eq(SchoolClassType::getTwoTime ,schoolClassType.getTwoTime());
        }
                                    if (schoolClassType.getThreeSimulationTime() != null){
            lqw.eq(SchoolClassType::getThreeSimulationTime ,schoolClassType.getThreeSimulationTime());
        }
                                    if (schoolClassType.getThreePracticeTime() != null){
            lqw.eq(SchoolClassType::getThreePracticeTime ,schoolClassType.getThreePracticeTime());
        }
                                    if (schoolClassType.getThreeTheoryTime() != null){
            lqw.eq(SchoolClassType::getThreeTheoryTime ,schoolClassType.getThreeTheoryTime());
        }
                                    if (StringUtils.isNotBlank(schoolClassType.getPhotoUrl())){
            lqw.eq(SchoolClassType::getPhotoUrl ,schoolClassType.getPhotoUrl());
        }
                                    if (schoolClassType.getRegionId() != null){
            lqw.eq(SchoolClassType::getRegionId ,schoolClassType.getRegionId());
        }
                                    if (StringUtils.isNotBlank(schoolClassType.getPdfUrl())){
            lqw.eq(SchoolClassType::getPdfUrl ,schoolClassType.getPdfUrl());
        }
                                    if (schoolClassType.getContractEndTime() != null){
            lqw.eq(SchoolClassType::getContractEndTime ,schoolClassType.getContractEndTime());
        }
                                    if (schoolClassType.getCreateTime() != null){
            lqw.eq(SchoolClassType::getCreateTime ,schoolClassType.getCreateTime());
        }
                    return this.list(lqw);
    }
}
